Index: gutenbach-client/debian/changelog
===================================================================
--- gutenbach-client/debian/changelog	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
+++ gutenbach-client/debian/changelog	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
@@ -0,0 +1,6 @@
+gutenbach-client (0.01) unstable; urgency=low
+
+  * Created skeleton package.
+
+ -- Jessica Hamrick <jhamrick@mit.edu>  Sat, 19 Jun 2010 00:23:53 -0400
+
Index: gutenbach-client/debian/compat
===================================================================
--- gutenbach-client/debian/compat	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
+++ gutenbach-client/debian/compat	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
@@ -0,0 +1,1 @@
+5
Index: gutenbach-client/debian/control
===================================================================
--- gutenbach-client/debian/control	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
+++ gutenbach-client/debian/control	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
@@ -0,0 +1,13 @@
+Source: gutenbach-client
+Section: sound
+Priority: extra
+Maintainer: Jessica Hamrick <jhamrick@mit.edu>
+Build-Depends: cdbs, debhelper (>= 7.4.15ubuntu1)
+Standards-Version: 3.8.4
+
+Package: gutenbach-client
+Architecture: all
+Pre-Depends: debconf
+Depends: ${shlibs:Depends}, ${misc:Depends}, cups, gutenbach
+Description: Client-side helper scripts for interacting with
+ the Gutenbach music player.
Index: gutenbach-client/debian/copyright
===================================================================
--- gutenbach-client/debian/copyright	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
+++ gutenbach-client/debian/copyright	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
@@ -0,0 +1,1 @@
+Copyright 2009 Jessica Hamrick
Index: gutenbach-client/debian/gutenbach-client.postinst
===================================================================
--- gutenbach-client/debian/gutenbach-client.postinst	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
+++ gutenbach-client/debian/gutenbach-client.postinst	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
@@ -0,0 +1,38 @@
+#!/bin/sh
+# postinst script for gutenbach-client
+#
+# see: dh_installdeb(1)
+
+set -e
+
+# summary of how this script can be called:
+#        * <postinst> `configure' <most-recently-configured-version>
+#        * <old-postinst> `abort-upgrade' <new version>
+#        * <conflictor's-postinst> `abort-remove' `in-favour' <package>
+#          <new-version>
+#        * <postinst> `abort-remove'
+#        * <deconfigured's-postinst> `abort-deconfigure' `in-favour'
+#          <failed-install-package> <version> `removing'
+#          <conflicting-package> <version>
+# for details, see http://www.debian.org/doc/debian-policy/ or
+# the debian-policy package
+
+case "$1" in
+    configure|reconfigure)
+    ;;
+
+    abort-upgrade|abort-remove|abort-deconfigure)
+    ;;
+
+    *)
+        echo "postinst called with unknown argument \`$1'" >&2
+        exit 1
+    ;;
+esac
+
+# dh_installdeb will replace this with shell code automatically
+# generated by other debhelper scripts.
+
+#DEBHELPER#
+
+exit 0
Index: gutenbach-client/debian/gutenbach-client.prerm
===================================================================
--- gutenbach-client/debian/gutenbach-client.prerm	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
+++ gutenbach-client/debian/gutenbach-client.prerm	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
@@ -0,0 +1,38 @@
+#!/bin/sh
+# prerm script for gutenbach-client
+#
+# see: dh_installdeb(1)
+
+set -e
+
+# summary of how this script can be called:
+#        * <prerm> `remove'
+#        * <old-prerm> `upgrade' <new-version>
+#        * <new-prerm> `failed-upgrade' <old-version>
+#        * <conflictor's-prerm> `remove' `in-favour' <package> <new-version>
+#        * <deconfigured's-prerm> `deconfigure' `in-favour'
+#          <package-being-installed> <version> `removing'
+#          <conflicting-package> <version>
+# for details, see http://www.debian.org/doc/debian-policy/ or
+# the debian-policy package
+
+
+case "$1" in
+    remove|upgrade|deconfigure)
+    ;;
+
+    failed-upgrade)
+    ;;
+
+    *)
+        echo "prerm called with unknown argument \`$1'" >&2
+        exit 1
+    ;;
+esac
+
+# dh_installdeb will replace this with shell code automatically
+# generated by other debhelper scripts.
+
+#DEBHELPER#
+
+exit 0
Index: gutenbach-client/debian/po/POTFILES.in
===================================================================
--- gutenbach-client/debian/po/POTFILES.in	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
+++ gutenbach-client/debian/po/POTFILES.in	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
@@ -0,0 +1,1 @@
+[type: gettext/rfc822deb] gutenbach.templates
Index: gutenbach-client/debian/po/templates.pot
===================================================================
--- gutenbach-client/debian/po/templates.pot	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
+++ gutenbach-client/debian/po/templates.pot	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
@@ -0,0 +1,64 @@
+# Gutenbach Translation File.
+#
+# This file is distributed under the same license as the GUTENBACH package.
+# Jessica B. Hamrick <jhamrick@mit.edu>, 2010.
+#
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: PACKAGE VERSION\n"
+"Report-Msgid-Bugs-To: gutenbach@mit.edu\n"
+"POT-Creation-Date: 2010-06-14 18:36-0600\n"
+"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
+"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
+"Language-Team: LANGUAGE <LL@li.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=CHARSET\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: string
+#. Description
+#: ../gutenbach.templates:1001
+msgid "Your gutenbach printer name:"
+msgstr ""
+
+#. Type: string
+#. Description
+#: ../gutenbach.templates:1001
+msgid ""
+"gutenbach creates a printer to which you can print music files.  gutenbach "
+"needs to know what you want to call the  printer, and then after "
+"installation, you will be able to do: lpr -Pprintername@hostname your-music-"
+"file-.mp3"
+msgstr ""
+
+#. Type: string
+#. Description
+#: ../gutenbach.templates:2001
+msgid "Your gutenbach zephyr class:"
+msgstr ""
+
+#. Type: string
+#. Description
+#: ../gutenbach.templates:2001
+msgid ""
+"When gutenbach plays a song, it sends a message to a zephyr class with the "
+"song information (title, artist, album, etc).  Please specify which class "
+"you would you these  zephyrs to be sent to.  If you don't know what this is, "
+"or you don't want zephyrs to be sent, just leave this  field blank."
+msgstr ""
+
+#. Type: string
+#. Description
+#: ../gutenbach.templates:3001
+msgid "The hostname to be displayed:"
+msgstr ""
+
+#. Type: string
+#. Description
+#: ../gutenbach.templates:3001
+msgid ""
+"When gutenbach sends a zephyr, it will display the hostname. If your "
+"hostname is particularly long, you may want to set this to an abbreviation "
+"or something else shorter."
+msgstr ""
Index: gutenbach-client/debian/rules
===================================================================
--- gutenbach-client/debian/rules	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
+++ gutenbach-client/debian/rules	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
@@ -0,0 +1,3 @@
+#!/usr/bin/make -f
+
+include /usr/share/cdbs/1/rules/debhelper.mk
Index: gutenbach-client/debian/source/format
===================================================================
--- gutenbach-client/debian/source/format	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
+++ gutenbach-client/debian/source/format	(revision 127d89c0b94110b2ad76b20fb770dc1ba93457c9)
@@ -0,0 +1,1 @@
+1.0
Index: tenbach-client/gutenbach-client/debian/changelog
===================================================================
--- gutenbach-client/gutenbach-client/debian/changelog	(revision fa75d329915e8c57a322e0861867f5255489b827)
+++ 	(revision )
@@ -1,6 +1,0 @@
-gutenbach-client (0.01) unstable; urgency=low
-
-  * Created skeleton package.
-
- -- Jessica Hamrick <jhamrick@mit.edu>  Sat, 19 Jun 2010 00:23:53 -0400
-
Index: tenbach-client/gutenbach-client/debian/compat
===================================================================
--- gutenbach-client/gutenbach-client/debian/compat	(revision fa75d329915e8c57a322e0861867f5255489b827)
+++ 	(revision )
@@ -1,1 +1,0 @@
-5
Index: tenbach-client/gutenbach-client/debian/control
===================================================================
--- gutenbach-client/gutenbach-client/debian/control	(revision fa75d329915e8c57a322e0861867f5255489b827)
+++ 	(revision )
@@ -1,13 +1,0 @@
-Source: gutenbach-client
-Section: sound
-Priority: extra
-Maintainer: Jessica Hamrick <jhamrick@mit.edu>
-Build-Depends: cdbs, debhelper (>= 7.4.15ubuntu1)
-Standards-Version: 3.8.4
-
-Package: gutenbach-client
-Architecture: all
-Pre-Depends: debconf
-Depends: ${shlibs:Depends}, ${misc:Depends}, cups, gutenbach
-Description: Client-side helper scripts for interacting with
- the Gutenbach music player.
Index: tenbach-client/gutenbach-client/debian/copyright
===================================================================
--- gutenbach-client/gutenbach-client/debian/copyright	(revision fa75d329915e8c57a322e0861867f5255489b827)
+++ 	(revision )
@@ -1,1 +1,0 @@
-Copyright 2009 Jessica Hamrick
Index: tenbach-client/gutenbach-client/debian/gutenbach-client.postinst
===================================================================
--- gutenbach-client/gutenbach-client/debian/gutenbach-client.postinst	(revision fa75d329915e8c57a322e0861867f5255489b827)
+++ 	(revision )
@@ -1,38 +1,0 @@
-#!/bin/sh
-# postinst script for gutenbach-client
-#
-# see: dh_installdeb(1)
-
-set -e
-
-# summary of how this script can be called:
-#        * <postinst> `configure' <most-recently-configured-version>
-#        * <old-postinst> `abort-upgrade' <new version>
-#        * <conflictor's-postinst> `abort-remove' `in-favour' <package>
-#          <new-version>
-#        * <postinst> `abort-remove'
-#        * <deconfigured's-postinst> `abort-deconfigure' `in-favour'
-#          <failed-install-package> <version> `removing'
-#          <conflicting-package> <version>
-# for details, see http://www.debian.org/doc/debian-policy/ or
-# the debian-policy package
-
-case "$1" in
-    configure|reconfigure)
-    ;;
-
-    abort-upgrade|abort-remove|abort-deconfigure)
-    ;;
-
-    *)
-        echo "postinst called with unknown argument \`$1'" >&2
-        exit 1
-    ;;
-esac
-
-# dh_installdeb will replace this with shell code automatically
-# generated by other debhelper scripts.
-
-#DEBHELPER#
-
-exit 0
Index: tenbach-client/gutenbach-client/debian/gutenbach-client.prerm
===================================================================
--- gutenbach-client/gutenbach-client/debian/gutenbach-client.prerm	(revision fa75d329915e8c57a322e0861867f5255489b827)
+++ 	(revision )
@@ -1,38 +1,0 @@
-#!/bin/sh
-# prerm script for gutenbach-client
-#
-# see: dh_installdeb(1)
-
-set -e
-
-# summary of how this script can be called:
-#        * <prerm> `remove'
-#        * <old-prerm> `upgrade' <new-version>
-#        * <new-prerm> `failed-upgrade' <old-version>
-#        * <conflictor's-prerm> `remove' `in-favour' <package> <new-version>
-#        * <deconfigured's-prerm> `deconfigure' `in-favour'
-#          <package-being-installed> <version> `removing'
-#          <conflicting-package> <version>
-# for details, see http://www.debian.org/doc/debian-policy/ or
-# the debian-policy package
-
-
-case "$1" in
-    remove|upgrade|deconfigure)
-    ;;
-
-    failed-upgrade)
-    ;;
-
-    *)
-        echo "prerm called with unknown argument \`$1'" >&2
-        exit 1
-    ;;
-esac
-
-# dh_installdeb will replace this with shell code automatically
-# generated by other debhelper scripts.
-
-#DEBHELPER#
-
-exit 0
Index: tenbach-client/gutenbach-client/debian/po/POTFILES.in
===================================================================
--- gutenbach-client/gutenbach-client/debian/po/POTFILES.in	(revision fa75d329915e8c57a322e0861867f5255489b827)
+++ 	(revision )
@@ -1,1 +1,0 @@
-[type: gettext/rfc822deb] gutenbach.templates
Index: tenbach-client/gutenbach-client/debian/po/templates.pot
===================================================================
--- gutenbach-client/gutenbach-client/debian/po/templates.pot	(revision fa75d329915e8c57a322e0861867f5255489b827)
+++ 	(revision )
@@ -1,64 +1,0 @@
-# Gutenbach Translation File.
-#
-# This file is distributed under the same license as the GUTENBACH package.
-# Jessica B. Hamrick <jhamrick@mit.edu>, 2010.
-#
-#
-msgid ""
-msgstr ""
-"Project-Id-Version: PACKAGE VERSION\n"
-"Report-Msgid-Bugs-To: gutenbach@mit.edu\n"
-"POT-Creation-Date: 2010-06-14 18:36-0600\n"
-"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
-"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
-"Language-Team: LANGUAGE <LL@li.org>\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=CHARSET\n"
-"Content-Transfer-Encoding: 8bit\n"
-
-#. Type: string
-#. Description
-#: ../gutenbach.templates:1001
-msgid "Your gutenbach printer name:"
-msgstr ""
-
-#. Type: string
-#. Description
-#: ../gutenbach.templates:1001
-msgid ""
-"gutenbach creates a printer to which you can print music files.  gutenbach "
-"needs to know what you want to call the  printer, and then after "
-"installation, you will be able to do: lpr -Pprintername@hostname your-music-"
-"file-.mp3"
-msgstr ""
-
-#. Type: string
-#. Description
-#: ../gutenbach.templates:2001
-msgid "Your gutenbach zephyr class:"
-msgstr ""
-
-#. Type: string
-#. Description
-#: ../gutenbach.templates:2001
-msgid ""
-"When gutenbach plays a song, it sends a message to a zephyr class with the "
-"song information (title, artist, album, etc).  Please specify which class "
-"you would you these  zephyrs to be sent to.  If you don't know what this is, "
-"or you don't want zephyrs to be sent, just leave this  field blank."
-msgstr ""
-
-#. Type: string
-#. Description
-#: ../gutenbach.templates:3001
-msgid "The hostname to be displayed:"
-msgstr ""
-
-#. Type: string
-#. Description
-#: ../gutenbach.templates:3001
-msgid ""
-"When gutenbach sends a zephyr, it will display the hostname. If your "
-"hostname is particularly long, you may want to set this to an abbreviation "
-"or something else shorter."
-msgstr ""
Index: tenbach-client/gutenbach-client/debian/rules
===================================================================
--- gutenbach-client/gutenbach-client/debian/rules	(revision fa75d329915e8c57a322e0861867f5255489b827)
+++ 	(revision )
@@ -1,3 +1,0 @@
-#!/usr/bin/make -f
-
-include /usr/share/cdbs/1/rules/debhelper.mk
Index: tenbach-client/gutenbach-client/debian/source/format
===================================================================
--- gutenbach-client/gutenbach-client/debian/source/format	(revision fa75d329915e8c57a322e0861867f5255489b827)
+++ 	(revision )
@@ -1,1 +1,0 @@
-1.0